<?php

include_once '../../plugins/vendor/autoload.php';

use Firebase\JWT\JWT;
use Firebase\JWT\Key;
use Dotenv\Dotenv;

class Seguridad {
    private function obtenerLlaveSecreta()
    {
        $dotenv = Dotenv::createImmutable(dirname(__DIR__, 1));
        $dotenv->load();

        return $_ENV['SECRET_KEY'];
    }

    public function generarJWT($codigousuario, $correoelectronico)
    {
        $tiempo = time();

        $payload = array(
            'iat' => $tiempo,
            'exp' => $tiempo + (60 * 60 * 24),
            'data' => [
                'codigousuario' => $codigousuario,
                'correoelectronico' => $correoelectronico
            ]
        );

        $JWT = JWT::encode($payload, $this->obtenerLlaveSecreta(), 'HS256');

        return array(
            'token' => 'Bearer ' . $JWT
        );
    }

    public function validarJWT($headers)
    {
        try {
            if(!isset($headers['Authorization']) || empty($headers['Authorization'])) {
                return array(
                    'mensaje' => 'Se requiere autenticación para consumir el recurso.', 
                    'estadojwt' => false
                );
            }

            $token = $headers['Authorization'];
            $JWT = explode(' ', $token)[1];
            $validacion = JWT::decode($JWT, new Key($this->obtenerLlaveSecreta(), 'HS256'));

            return $validacion->data;
        } catch (\Throwable $th) {
            return array(
                'mensaje' => "No está autorizado para consumir el recurso: " . $th->getMessage() . ".", 
                'estadojwt' => false
            );
        }
    }
}