<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: *');

if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') exit;

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    //Autenticación y Autorización
    require_once('../../utilidades/FuncionesGlobales.php');
    $headers = getallheaders();
    ValidarAuthControladores($headers);

    //Proceso
    include_once '../../servicios/ServicioRequerimiento.php';

    $data = json_decode(file_get_contents("php://input"), true);

    $servicioRequerimiento = new ServicioRequerimiento();

    $_informacioninventario = $data['informacioninventario'];

    if (is_array($_informacioninventario) && count($_informacioninventario) > 0) {
        for ($i = 0; $i < count($_informacioninventario); $i++) {
            $imagen = $_informacioninventario[$i]['imagen'];
            $nombreArchivo = generateRandomFileName();
            $archivo = base64ToFile($imagen, $nombreArchivo);
            $_informacioninventario[$i]['urlimagen'] = returnBaseUrlProject() . "controladores/requerimiento/" . $archivo;
        }
    }

    $requerimiento = isset($_GET['requerimiento']) ? $_GET['requerimiento'] : 0;
    $zona = isset($_GET['zona']) ? $_GET['zona'] : 0;
    $tipoinventario = isset($_GET['tipoinventario']) ? $_GET['tipoinventario'] : 0;

    $respuesta = $servicioRequerimiento->crearinventario(
        $requerimiento,
        $zona,
        $tipoinventario,
        $_informacioninventario
    );

    echo $respuesta;
} else {
    echo json_encode(
        array('mensaje' => 'Error al consumir el recurso.', 'estado' => false)
    );
}
