<?php

include_once '../../configuracion/Conexion.php';

class RepositorioRequerimiento
{

    private $conexion;
    private $tabla = 'requerimiento';
    private $tablainventario = 'inventario';
    private $tablalog = 'logrequerimiento';

    public $codigotipopersona;
    public $codigotipodocumento;
    public $numerotipodocumento;
    public $nombres;
    public $apellidos;
    public $ruc;
    public $razonsocial;
    public $correoelectronico;
    public $codigoprefijotelefonico;
    public $telefono;
    public $numeroplacavehiculo;
    public $vinvehiculo;
    public $codigomarcavehiculo;
    public $codigomodelovehiculo;
    public $anovehiculo;
    public $codigocolorvehiculo;
    public $usuariocreacion;

    public $codigorequerimiento;
    public $codigotipoinventario;
    public $codigozona;
    public $detalle;
    public $urlimagen;
    public $codigoestado;

    public $fechainicio;
    public $fechafin;
    public $rucempresa;
    public $codigousuario;

    //Constructor
    public function __construct()
    {
        // Instanciar conexion BD
        $connection = new Conexion();
        $this->conexion = $connection->conectar();
    }

    public function crear()
    {
        // Crear query  
        $query = 'INSERT INTO ' . $this->tabla . "(
        codigotipopersona,
        codigotipodocumento,
        numerotipodocumento,
        nombres,
        apellidos,
        ruc,
        razonsocial,
        correoelectronico,
        codigoprefijotelefonico,
        telefono,
        numeroplacavehiculo,
        vinvehiculo,
        codigomarcavehiculo,
        codigomodelovehiculo,
        anovehiculo,
        codigocolorvehiculo,
        fechahoracreacion,
        usuariocreacion,
        codigoestado) 
        VALUES (
        :codigotipopersona,
        :codigotipodocumento,
        :numerotipodocumento,
        :nombres,
        :apellidos,
        :ruc,
        :razonsocial,
        :correoelectronico,
        :codigoprefijotelefonico,
        :telefono,
        :numeroplacavehiculo,
        :vinvehiculo,
        :codigomarcavehiculo,
        :codigomodelovehiculo,
        :anovehiculo,
        :codigocolorvehiculo,
        NOW(),
        :usuariocreacion,
        1)";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query);

        // Limpiar propiedades
        $this->codigotipopersona = htmlspecialchars($this->codigotipopersona ?? 0);
        $this->codigotipodocumento = htmlspecialchars($this->codigotipodocumento ?? 0);
        $this->numerotipodocumento = htmlspecialchars($this->numerotipodocumento ?? '');
        $this->nombres = htmlspecialchars($this->nombres ?? '');
        $this->apellidos = htmlspecialchars($this->apellidos ?? '');
        $this->ruc = htmlspecialchars($this->ruc ?? '');
        $this->razonsocial = htmlspecialchars($this->razonsocial ?? '');
        $this->correoelectronico = htmlspecialchars($this->correoelectronico ?? '');
        $this->codigoprefijotelefonico = htmlspecialchars($this->codigoprefijotelefonico ?? '');
        $this->telefono = htmlspecialchars($this->telefono ?? '');
        $this->numeroplacavehiculo = htmlspecialchars($this->numeroplacavehiculo ?? '');
        $this->vinvehiculo = htmlspecialchars($this->vinvehiculo ?? '');
        $this->codigomarcavehiculo = htmlspecialchars($this->codigomarcavehiculo ?? 0);
        $this->codigomodelovehiculo = htmlspecialchars($this->codigomodelovehiculo ?? 0);
        $this->anovehiculo = htmlspecialchars($this->anovehiculo ?? 0);
        $this->codigocolorvehiculo = htmlspecialchars($this->codigocolorvehiculo ?? 0);
        $this->usuariocreacion = htmlspecialchars($this->usuariocreacion ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigotipopersona", $this->codigotipopersona);
        $stmt->bindParam(":codigotipodocumento", $this->codigotipodocumento);
        $stmt->bindParam(":numerotipodocumento", $this->numerotipodocumento);
        $stmt->bindParam(":nombres", $this->nombres);
        $stmt->bindParam(":apellidos", $this->apellidos);
        $stmt->bindParam(":ruc", $this->ruc);
        $stmt->bindParam(":razonsocial", $this->razonsocial);
        $stmt->bindParam(":correoelectronico", $this->correoelectronico);
        $stmt->bindParam(":codigoprefijotelefonico", $this->codigoprefijotelefonico);
        $stmt->bindParam(":telefono", $this->telefono);
        $stmt->bindParam(":numeroplacavehiculo", $this->numeroplacavehiculo);
        $stmt->bindParam(":vinvehiculo", $this->vinvehiculo);
        $stmt->bindParam(":codigomarcavehiculo", $this->codigomarcavehiculo);
        $stmt->bindParam(":codigomodelovehiculo", $this->codigomodelovehiculo);
        $stmt->bindParam(":anovehiculo", $this->anovehiculo);
        $stmt->bindParam(":codigocolorvehiculo", $this->codigocolorvehiculo);
        $stmt->bindParam(":usuariocreacion", $this->usuariocreacion);

        // Ejecutar setencia y enviar resultado
        if ($stmt->execute()) {
            return $this->conexion->lastInsertId();
        }

        printf("Error $s.\n", $stmt->error);
        return false;
    }
    public function crearlogrequerimiento()
    {
        // Crear query  
        $query = 'INSERT INTO ' . $this->tablalog . "(
        codigorequerimiento,
        codigoestado,
        codigousuario,
        fechahora) 
        VALUES (
        :codigorequerimiento,
        :codigoestado,
        :codigousuario,
        NOW())";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query);

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigoestado = htmlspecialchars($this->codigoestado ?? 0);
        $this->codigousuario = htmlspecialchars($this->codigousuario ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigoestado", $this->codigoestado);
        $stmt->bindParam(":codigousuario", $this->codigousuario);

        // Ejecutar setencia y enviar resultado
        if ($stmt->execute()) {
            return $this->conexion->lastInsertId();
        }

        printf("Error $s.\n", $stmt->error);
        return false;
    }
    public function listar()
    {
        $query = 'SELECT 
        t1.codigorequerimiento,
        t1.codigotipopersona,
        t2.descripciontipopersona,
        t1.codigotipodocumento,
        t3.descripciontipodocumento,
        t1.numerotipodocumento,
        t1.nombres,
        t1.apellidos,
        t1.ruc,
        t1.razonsocial,
        t1.correoelectronico,
        t1.telefono,
        t1.numeroplacavehiculo,
        t1.vinvehiculo,
        t1.codigomarcavehiculo,
        t1.codigomodelovehiculo,
        t1.anovehiculo,
        t1.codigocolorvehiculo,
        t1.fechahoracreacion,
        t1.usuariocreacion,
        t7.correoelectronico AS correoelectronicousuariocreacion,
        t1.codigoestado,
        t8.descripcionestado
        FROM ' . $this->tabla . " t1 
        INNER JOIN tipopersona t2 ON t2.codigotipopersona = t1.codigotipopersona
        INNER JOIN tipodocumento t3 ON t3.codigotipodocumento = t1.codigotipodocumento
        INNER JOIN usuario t7 ON t7.codigousuario = t1.usuariocreacion
        INNER JOIN estado t8 ON t8.codigoestado = t1.codigoestado
        ORDER BY t1.fechahoracreacion DESC";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarporestado()
    {
        $query = 'SELECT 
        t1.codigorequerimiento,
        t1.codigotipopersona,
        t2.descripciontipopersona,
        t1.codigotipodocumento,
        t3.descripciontipodocumento,
        t1.numerotipodocumento,
        t1.nombres,
        t1.apellidos,
        t1.ruc,
        t1.razonsocial,
        t1.correoelectronico,
        t1.telefono,
        t1.numeroplacavehiculo,
        t1.vinvehiculo,
        t1.codigomarcavehiculo,
        t1.codigomodelovehiculo,
        t1.anovehiculo,
        t1.codigocolorvehiculo,
        t1.fechahoracreacion,
        t1.usuariocreacion,
        t7.correoelectronico AS correoelectronicousuariocreacion,
        t1.codigoestado,
        t8.descripcionestado
        FROM ' . $this->tabla . " t1 
        INNER JOIN tipopersona t2 ON t2.codigotipopersona = t1.codigotipopersona
        INNER JOIN tipodocumento t3 ON t3.codigotipodocumento = t1.codigotipodocumento
        INNER JOIN usuario t7 ON t7.codigousuario = t1.usuariocreacion
        INNER JOIN estado t8 ON t8.codigoestado = t1.codigoestado
        WHERE t1.codigoestado = :codigoestado
        ORDER BY t1.fechahoracreacion DESC";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigoestado = htmlspecialchars($this->codigoestado ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigoestado", $this->codigoestado);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarporestadofechacreacionrucempresa()
    {
        $query = 'SELECT 
        t1.codigorequerimiento,
        t1.codigotipopersona,
        t2.descripciontipopersona,
        t1.codigotipodocumento,
        t3.descripciontipodocumento,
        t1.numerotipodocumento,
        t1.nombres,
        t1.apellidos,
        t1.ruc,
        t1.razonsocial,
        t1.correoelectronico,
        t1.telefono,
        t1.numeroplacavehiculo,
        t1.vinvehiculo,
        t1.codigomarcavehiculo,
        t1.codigomodelovehiculo,
        t1.anovehiculo,
        t1.codigocolorvehiculo,
        t1.fechahoracreacion,
        t1.usuariocreacion,
        t7.correoelectronico AS correoelectronicousuariocreacion,
        t1.codigoestado,
        t8.descripcionestado
        FROM ' . $this->tabla . " t1 
        INNER JOIN tipopersona t2 ON t2.codigotipopersona = t1.codigotipopersona
        INNER JOIN tipodocumento t3 ON t3.codigotipodocumento = t1.codigotipodocumento
        INNER JOIN usuario t7 ON t7.codigousuario = t1.usuariocreacion
        INNER JOIN estado t8 ON t8.codigoestado = t1.codigoestado
        WHERE t1.codigoestado = :codigoestado AND t7.rucempresa = :rucempresa AND DATE(t1.fechahoracreacion) BETWEEN :fechainicio AND :fechafin
        ORDER BY t1.fechahoracreacion DESC";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigoestado = htmlspecialchars($this->codigoestado ?? 0);
        $this->fechainicio = htmlspecialchars($this->fechainicio ?? '');
        $this->fechafin = htmlspecialchars($this->fechafin ?? '');
        $this->rucempresa = htmlspecialchars($this->rucempresa ?? '');

        // Bindear propiedades
        $stmt->bindParam(":codigoestado", $this->codigoestado);
        $stmt->bindParam(":fechainicio", $this->fechainicio);
        $stmt->bindParam(":fechafin", $this->fechafin);
        $stmt->bindParam(":rucempresa", $this->rucempresa);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarporfechacreacionrucempresa()
    {
        $query = 'SELECT 
        t1.codigorequerimiento,
        t1.codigotipopersona,
        t2.descripciontipopersona,
        t1.codigotipodocumento,
        t3.descripciontipodocumento,
        t1.numerotipodocumento,
        t1.nombres,
        t1.apellidos,
        t1.ruc,
        t1.razonsocial,
        t1.correoelectronico,
        t1.telefono,
        t1.numeroplacavehiculo,
        t1.vinvehiculo,
        t1.codigomarcavehiculo,
        t1.codigomodelovehiculo,
        t1.anovehiculo,
        t1.codigocolorvehiculo,
        t1.fechahoracreacion,
        t1.usuariocreacion,
        t7.correoelectronico AS correoelectronicousuariocreacion,
        t1.codigoestado,
        t8.descripcionestado
        FROM ' . $this->tabla . " t1 
        INNER JOIN tipopersona t2 ON t2.codigotipopersona = t1.codigotipopersona
        INNER JOIN tipodocumento t3 ON t3.codigotipodocumento = t1.codigotipodocumento
        INNER JOIN usuario t7 ON t7.codigousuario = t1.usuariocreacion
        INNER JOIN estado t8 ON t8.codigoestado = t1.codigoestado
        WHERE t7.rucempresa = :rucempresa AND DATE(t1.fechahoracreacion) BETWEEN :fechainicio AND :fechafin
        ORDER BY t1.fechahoracreacion DESC";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->fechainicio = htmlspecialchars($this->fechainicio ?? '');
        $this->fechafin = htmlspecialchars($this->fechafin ?? '');
        $this->rucempresa = htmlspecialchars($this->rucempresa ?? '');

        // Bindear propiedades
        $stmt->bindParam(":fechainicio", $this->fechainicio);
        $stmt->bindParam(":fechafin", $this->fechafin);
        $stmt->bindParam(":rucempresa", $this->rucempresa);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarporcodigo()
    {
        $query = 'SELECT 
        t1.codigorequerimiento,
        t1.codigotipopersona,
        t2.descripciontipopersona,
        t1.codigotipodocumento,
        t3.descripciontipodocumento,
        t1.numerotipodocumento,
        t1.nombres,
        t1.apellidos,
        t1.ruc,
        t1.razonsocial,
        t1.correoelectronico,
        t1.telefono,
        t1.numeroplacavehiculo,
        t1.vinvehiculo,
        t1.codigomarcavehiculo,
        t1.codigomodelovehiculo,
        t1.anovehiculo,
        t1.codigocolorvehiculo,
        t1.fechahoracreacion,
        t1.usuariocreacion,
        t7.correoelectronico AS correoelectronicousuariocreacion,
        t7.nombre AS nombreusuariocreacion,
        t7.apellido AS apellidousuariocreacion,
        t1.codigoestado,
        t8.descripcionestado
        FROM ' . $this->tabla . " t1 
        INNER JOIN tipopersona t2 ON t2.codigotipopersona = t1.codigotipopersona
        INNER JOIN tipodocumento t3 ON t3.codigotipodocumento = t1.codigotipodocumento
        INNER JOIN usuario t7 ON t7.codigousuario = t1.usuariocreacion
        INNER JOIN estado t8 ON t8.codigoestado = t1.codigoestado
        WHERE t1.codigorequerimiento = :codigorequerimiento";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarinventario()
    {
        $query = 'SELECT 
        t1.codigoinventario,
        t1.codigorequerimiento,
        t1.codigotipoinventario,
        t2.descripciontipoinventario,
        t1.codigozona,
        t3.descripcionzona,
        t1.detalle,
        t1.urlimagen,
        t3.urlicono
        FROM ' . $this->tablainventario . " t1 
        INNER JOIN tipoinventario t2 ON t2.codigotipoinventario = t1.codigotipoinventario
        INNER JOIN zona t3 ON t3.codigozona = t1.codigozona
        WHERE t1.codigorequerimiento = :codigorequerimiento";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarinventarioporrequerimientozonatipoinventario()
    {
        $query = 'SELECT 
        t1.codigoinventario,
        t1.codigorequerimiento,
        t1.codigotipoinventario,
        t2.descripciontipoinventario,
        t1.codigozona,
        t3.descripcionzona,
        t1.detalle,
        t1.urlimagen
        FROM ' . $this->tablainventario . " t1 
        INNER JOIN tipoinventario t2 ON t2.codigotipoinventario = t1.codigotipoinventario
        INNER JOIN zona t3 ON t3.codigozona = t1.codigozona
        WHERE t1.codigorequerimiento = :codigorequerimiento AND t1.codigozona = :codigozona AND t1.codigotipoinventario = :codigotipoinventario";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigozona = htmlspecialchars($this->codigozona ?? 0);
        $this->codigotipoinventario = htmlspecialchars($this->codigotipoinventario ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigozona", $this->codigozona);
        $stmt->bindParam(":codigotipoinventario", $this->codigotipoinventario);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function listarmininventarioporrequerimientozonatipoinventario()
    {
        $query = 'SELECT 
        t1.codigoinventario,
        t1.codigorequerimiento,
        t1.codigotipoinventario,
        t2.descripciontipoinventario,
        t1.codigozona,
        t3.descripcionzona,
        t1.detalle,
        t1.urlimagen
        FROM ' . $this->tablainventario . " t1 
        INNER JOIN tipoinventario t2 ON t2.codigotipoinventario = t1.codigotipoinventario
        INNER JOIN zona t3 ON t3.codigozona = t1.codigozona
        WHERE t1.codigorequerimiento = :codigorequerimiento AND t1.codigozona = :codigozona AND t1.codigotipoinventario = :codigotipoinventario AND 
        t1.codigoinventario = (SELECT MIN(codigoinventario) FROM inventario WHERE codigorequerimiento = :codigorequerimiento AND codigozona = :codigozona AND codigotipoinventario = :codigotipoinventario);";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query, array(PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL));

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigozona = htmlspecialchars($this->codigozona ?? 0);
        $this->codigotipoinventario = htmlspecialchars($this->codigotipoinventario ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigozona", $this->codigozona);
        $stmt->bindParam(":codigotipoinventario", $this->codigotipoinventario);

        // Ejecutar setencia y enviar resultado
        $stmt->execute();
        return $stmt;
    }
    public function crearinventario()
    {
        // Crear query  
        $query = 'INSERT INTO ' . $this->tablainventario . "(
        codigorequerimiento,
        codigotipoinventario,
        codigozona,
        detalle,
        urlimagen)
        VALUES (
        :codigorequerimiento,
        :codigotipoinventario,
        :codigozona,
        :detalle,
        :urlimagen)";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query);

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigotipoinventario = htmlspecialchars($this->codigotipoinventario ?? 0);
        $this->codigozona = htmlspecialchars($this->codigozona ?? 0);
        $this->detalle = htmlspecialchars($this->detalle ?? '');
        $this->urlimagen = htmlspecialchars($this->urlimagen ?? '');

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigotipoinventario", $this->codigotipoinventario);
        $stmt->bindParam(":codigozona", $this->codigozona);
        $stmt->bindParam(":detalle", $this->detalle);
        $stmt->bindParam(":urlimagen", $this->urlimagen);

        // Ejecutar setencia y enviar resultado
        if ($stmt->execute()) {
            return true;
        }

        printf("Error $s.\n", $stmt->error);
        return false;
    }
    public function eliminarinventarioporrequerimientozonatipoinventario()
    {
        // Crear query  
        $query = 'DELETE FROM ' . $this->tablainventario . " WHERE codigorequerimiento = :codigorequerimiento AND codigozona = :codigozona AND codigotipoinventario = :codigotipoinventario";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query);

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigozona = htmlspecialchars($this->codigozona ?? 0);
        $this->codigotipoinventario = htmlspecialchars($this->codigotipoinventario ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigozona", $this->codigozona);
        $stmt->bindParam(":codigotipoinventario", $this->codigotipoinventario);

        // Ejecutar setencia y enviar resultado
        if ($stmt->execute()) {
            return true;
        }

        printf("Error $s.\n", $stmt->error);
        return false;
    }
    public function actualizarestado()
    {
        // Crear query  
        $query = 'UPDATE ' . $this->tabla . "
        SET codigoestado = :codigoestado
        WHERE codigorequerimiento = :codigorequerimiento";

        // Preparar setencia
        $stmt = $this->conexion->prepare($query);

        // Limpiar propiedades
        $this->codigorequerimiento = htmlspecialchars($this->codigorequerimiento ?? 0);
        $this->codigoestado = htmlspecialchars($this->codigoestado ?? 0);

        // Bindear propiedades
        $stmt->bindParam(":codigorequerimiento", $this->codigorequerimiento);
        $stmt->bindParam(":codigoestado", $this->codigoestado);

        // Ejecutar setencia y enviar resultado
        if ($stmt->execute()) {
            return true;
        }

        printf("Error $s.\n", $stmt->error);
        return false;
    }
}
