<?php

include_once '../../infraestructura/MySQL/RepositorioRequerimiento.php';
include_once '../../infraestructura/MySQL/RepositorioEstado.php';

class ServicioRequerimiento
{
    private $_repositorioRequerimiento;
    private $_repositorioEstado;

    //Construct
    public function __construct()
    {
        $this->_repositorioRequerimiento = new RepositorioRequerimiento();
        $this->_repositorioEstado = new RepositorioEstado();
    }

    public function crear(
        $codigotipopersona,
        $codigotipodocumento,
        $numerotipodocumento,
        $nombres,
        $apellidos,
        $ruc,
        $razonsocial,
        $correoelectronico,
        $codigoprefijotelefonico,
        $telefono,
        $numeroplacavehiculo,
        $vinvehiculo,
        $codigomarcavehiculo,
        $codigomodelovehiculo,
        $anovehiculo,
        $codigocolorvehiculo,
        $usuariocreacion
    ) {

        $this->_repositorioRequerimiento->codigotipopersona = $codigotipopersona;
        $this->_repositorioRequerimiento->codigotipodocumento = $codigotipodocumento;
        $this->_repositorioRequerimiento->numerotipodocumento = $numerotipodocumento;
        $this->_repositorioRequerimiento->nombres = $nombres;
        $this->_repositorioRequerimiento->apellidos = $apellidos;
        $this->_repositorioRequerimiento->ruc = $ruc;
        $this->_repositorioRequerimiento->razonsocial = $razonsocial;
        $this->_repositorioRequerimiento->correoelectronico = $correoelectronico;
        $this->_repositorioRequerimiento->codigoprefijotelefonico = $codigoprefijotelefonico;
        $this->_repositorioRequerimiento->telefono = $telefono;
        $this->_repositorioRequerimiento->numeroplacavehiculo = $numeroplacavehiculo;
        $this->_repositorioRequerimiento->vinvehiculo = $vinvehiculo;
        $this->_repositorioRequerimiento->codigomarcavehiculo = $codigomarcavehiculo;
        $this->_repositorioRequerimiento->codigomodelovehiculo = $codigomodelovehiculo;
        $this->_repositorioRequerimiento->anovehiculo = $anovehiculo;
        $this->_repositorioRequerimiento->codigocolorvehiculo = $codigocolorvehiculo;
        $this->_repositorioRequerimiento->usuariocreacion = $usuariocreacion;

        // Ejecutar la funcion del repositorio
        $codigorequerimiento =  $this->_repositorioRequerimiento->crear();

        // Crear respueta
        if ($codigorequerimiento > 0) {

            $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;
            $this->_repositorioRequerimiento->codigoestado = 1;
            $this->_repositorioRequerimiento->codigousuario = $usuariocreacion;
            $this->_repositorioRequerimiento->crearlogrequerimiento();

            $respuesta = json_encode(
                array('mensaje' => 'Requerimiento registrado correctamente.', 'estado' => true, 'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT), 'codigorequerimientoreal' => $codigorequerimiento)
            );
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Error al registrar el requerimiento.', 'estado' => false)
            );
        }
        // Enviar respuesta
        return $respuesta;
    }

    public function crearmasivo(
        $requerimientos,
        $usuariocreacion
    ) {

        if (is_array($requerimientos) && count($requerimientos) > 0) {

            $cantidadrequerimientos = count($requerimientos);
            $requerimientoprocesados = 0;

            $this->_repositorioRequerimiento->usuariocreacion = $usuariocreacion;
            $this->_repositorioRequerimiento->codigoestado = 1;
            $this->_repositorioRequerimiento->codigousuario = $usuariocreacion;

            for ($x = 0; $x < count($requerimientos); $x++) {

                $codigotipopersona = (array_key_exists('codigotipopersona', $requerimientos[$x])) ? $requerimientos[$x]['codigotipopersona'] : 0;
                $codigotipodocumento = (array_key_exists('codigotipodocumento', $requerimientos[$x])) ? $requerimientos[$x]['codigotipodocumento'] : 0;
                $numerotipodocumento = (array_key_exists('numerotipodocumento', $requerimientos[$x])) ? $requerimientos[$x]['numerotipodocumento'] : '';
                $nombres = (array_key_exists('nombres', $requerimientos[$x])) ? $requerimientos[$x]['nombres'] : '';
                $apellidos = (array_key_exists('apellidos', $requerimientos[$x])) ? $requerimientos[$x]['apellidos'] : '';
                $ruc = (array_key_exists('ruc', $requerimientos[$x])) ? $requerimientos[$x]['ruc'] : '';
                $razonsocial = (array_key_exists('razonsocial', $requerimientos[$x])) ? $requerimientos[$x]['razonsocial'] : '';
                $correoelectronico = (array_key_exists('correoelectronico', $requerimientos[$x])) ? $requerimientos[$x]['correoelectronico'] : '';
                $codigoprefijotelefonico = (array_key_exists('codigoprefijotelefonico', $requerimientos[$x])) ? $requerimientos[$x]['codigoprefijotelefonico'] : '';
                $telefono = (array_key_exists('telefono', $requerimientos[$x])) ? $requerimientos[$x]['telefono'] : '';
                $numeroplacavehiculo = (array_key_exists('numeroplacavehiculo', $requerimientos[$x])) ? $requerimientos[$x]['numeroplacavehiculo'] : '';
                $vinvehiculo = (array_key_exists('vinvehiculo', $requerimientos[$x])) ? $requerimientos[$x]['vinvehiculo'] : '';
                $codigomarcavehiculo = (array_key_exists('codigomarcavehiculo', $requerimientos[$x])) ? $requerimientos[$x]['codigomarcavehiculo'] : 0;
                $codigomodelovehiculo = (array_key_exists('codigomodelovehiculo', $requerimientos[$x])) ? $requerimientos[$x]['codigomodelovehiculo'] : 0;
                $anovehiculo = (array_key_exists('anovehiculo', $requerimientos[$x])) ? $requerimientos[$x]['anovehiculo'] : 0;
                $codigocolorvehiculo = (array_key_exists('codigocolorvehiculo', $requerimientos[$x])) ? $requerimientos[$x]['codigocolorvehiculo'] : 0;

                $this->_repositorioRequerimiento->codigotipopersona = $codigotipopersona;
                $this->_repositorioRequerimiento->codigotipodocumento = $codigotipodocumento;
                $this->_repositorioRequerimiento->numerotipodocumento = $numerotipodocumento;
                $this->_repositorioRequerimiento->nombres = $nombres;
                $this->_repositorioRequerimiento->apellidos = $apellidos;
                $this->_repositorioRequerimiento->ruc = $ruc;
                $this->_repositorioRequerimiento->razonsocial = $razonsocial;
                $this->_repositorioRequerimiento->correoelectronico = $correoelectronico;
                $this->_repositorioRequerimiento->codigoprefijotelefonico = $codigoprefijotelefonico;
                $this->_repositorioRequerimiento->telefono = $telefono;
                $this->_repositorioRequerimiento->numeroplacavehiculo = $numeroplacavehiculo;
                $this->_repositorioRequerimiento->vinvehiculo = $vinvehiculo;
                $this->_repositorioRequerimiento->codigomarcavehiculo = $codigomarcavehiculo;
                $this->_repositorioRequerimiento->codigomodelovehiculo = $codigomodelovehiculo;
                $this->_repositorioRequerimiento->anovehiculo = $anovehiculo;
                $this->_repositorioRequerimiento->codigocolorvehiculo = $codigocolorvehiculo;

                // Ejecutar la funcion del repositorio
                $this->_repositorioRequerimiento->crear();
                $this->_repositorioRequerimiento->crearlogrequerimiento();


                $requerimientoprocesados++;
            }

            $respuesta = json_encode(
                array('mensaje' => "Requerimiento procesados {$requerimientoprocesados}/{$cantidadrequerimientos}", 'estado' => true)
            );
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        // Enviar respuesta
        return $respuesta;
    }

    public function actualizarestado(
        $codigorequerimiento,
        $codigoestado,
        $codigousuario
    ) {

        $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;
        $this->_repositorioRequerimiento->codigoestado = $codigoestado;

        // Ejecutar la funcion del repositorio
        $codigorequerimiento =  $this->_repositorioRequerimiento->actualizarestado();

        // Crear respueta
        if ($codigorequerimiento > 0) {

            $this->_repositorioRequerimiento->codigousuario = $codigousuario;
            $this->_repositorioRequerimiento->crearlogrequerimiento();

            $respuesta = json_encode(
                array('mensaje' => 'Requerimiento actualizado correctamente.', 'estado' => true)
            );
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Error al actualizar el requerimiento.', 'estado' => false)
            );
        }
        // Enviar respuesta
        return $respuesta;
    }

    public function listar()
    {

        // Ejecutar la funcion del repositorio
        $resultado = $this->_repositorioRequerimiento->listar();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas > 0) {
            $array_completo = array();

            while ($row = $resultado->fetch(PDO::FETCH_ASSOC)) {
                extract($row);

                $array_row = array(
                    'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                    'codigorequerimientoreal' => $codigorequerimiento,
                    'codigotipopersona' => $codigotipopersona,
                    'descripciontipopersona' => $descripciontipopersona,
                    'codigotipodocumento' => $codigotipodocumento,
                    'descripciontipodocumento' => $descripciontipodocumento,
                    'numerotipodocumento' => $numerotipodocumento,
                    'nombres' => $nombres,
                    'apellidos' => $apellidos,
                    'ruc' => $ruc,
                    'razonsocial' => $razonsocial,
                    'correoelectronico' => $correoelectronico,
                    'telefono' => $telefono,
                    'numeroplacavehiculo' => $numeroplacavehiculo,
                    'vinvehiculo' => $vinvehiculo,
                    'codigomarcavehiculo' => $codigomarcavehiculo,
                    'codigomodelovehiculo' => $codigomodelovehiculo,
                    'urlimagenmodelovehiculo' => 'https://droidconsultingti.com/droid.reparaciones.api/imagenes/icono-carro.png',
                    'anovehiculo' => $anovehiculo,
                    'codigocolorvehiculo' => $codigocolorvehiculo,
                    'fechahoracreacion' => $fechahoracreacion,
                    'usuariocreacion' => $usuariocreacion,
                    'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                array_push($array_completo, $array_row);
            }

            // Crear respueta
            $respuesta = json_encode($array_completo);
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function listarporestado($estado)
    {

        $this->_repositorioRequerimiento->codigoestado = $estado;
        // Ejecutar la funcion del repositorio
        $resultado = $this->_repositorioRequerimiento->listarporestado();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas > 0) {
            $array_completo = array();

            while ($row = $resultado->fetch(PDO::FETCH_ASSOC)) {
                extract($row);

                $array_row = array(
                    'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                    'codigorequerimientoreal' => $codigorequerimiento,
                    'codigotipopersona' => $codigotipopersona,
                    'descripciontipopersona' => $descripciontipopersona,
                    'codigotipodocumento' => $codigotipodocumento,
                    'descripciontipodocumento' => $descripciontipodocumento,
                    'numerotipodocumento' => $numerotipodocumento,
                    'nombres' => $nombres,
                    'apellidos' => $apellidos,
                    'ruc' => $ruc,
                    'razonsocial' => $razonsocial,
                    'correoelectronico' => $correoelectronico,
                    'telefono' => $telefono,
                    'numeroplacavehiculo' => $numeroplacavehiculo,
                    'vinvehiculo' => $vinvehiculo,
                    'codigomarcavehiculo' => $codigomarcavehiculo,
                    'codigomodelovehiculo' => $codigomodelovehiculo,
                    'urlimagenmodelovehiculo' => 'https://droidconsultingti.com/droid.reparaciones.api/imagenes/icono-carro.png',
                    'anovehiculo' => $anovehiculo,
                    'codigocolorvehiculo' => $codigocolorvehiculo,
                    'fechahoracreacion' => $fechahoracreacion,
                    'usuariocreacion' => $usuariocreacion,
                    'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                array_push($array_completo, $array_row);
            }

            // Crear respueta
            $respuesta = json_encode($array_completo);
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function listarporcodigoestadofechacreacionrucempresa($fechainicio, $fechafin, $rucempresa, $estado)
    {

        $this->_repositorioRequerimiento->fechainicio = $fechainicio;
        $this->_repositorioRequerimiento->fechafin = $fechafin;
        $this->_repositorioRequerimiento->rucempresa = $rucempresa;

        if ($estado != '-') {
            $this->_repositorioRequerimiento->codigoestado = $estado;
            // Ejecutar la funcion del repositorio
            $resultadolistarporestadofechacreacion = $this->_repositorioRequerimiento->listarporestadofechacreacionrucempresa();
        } else {
            // Ejecutar la funcion del repositorio
            $resultadolistarporestadofechacreacion = $this->_repositorioRequerimiento->listarporfechacreacionrucempresa();
        }

        // Conteo de filas
        $numerofilaslistarporestadofechacreacion = $resultadolistarporestadofechacreacion->rowCount();

        if ($numerofilaslistarporestadofechacreacion > 0) {

            $array_completo_requerimiento = array();

            while ($rowlistarporestadofechacreacion = $resultadolistarporestadofechacreacion->fetch(PDO::FETCH_ASSOC)) {
                extract($rowlistarporestadofechacreacion);

                $array_row_requerimiento = array(
                    'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                    'codigorequerimientoreal' => $codigorequerimiento,
                    'codigotipopersona' => $codigotipopersona,
                    'descripciontipopersona' => $descripciontipopersona,
                    'codigotipodocumento' => $codigotipodocumento,
                    'descripciontipodocumento' => $descripciontipodocumento,
                    'numerotipodocumento' => $numerotipodocumento,
                    'nombres' => $nombres,
                    'apellidos' => $apellidos,
                    'ruc' => $ruc,
                    'razonsocial' => $razonsocial,
                    'correoelectronico' => $correoelectronico,
                    'telefono' => $telefono,
                    'numeroplacavehiculo' => $numeroplacavehiculo,
                    'vinvehiculo' => $vinvehiculo,
                    'codigomarcavehiculo' => $codigomarcavehiculo,
                    'codigomodelovehiculo' => $codigomodelovehiculo,
                    'urlimagenmodelovehiculo' => 'https://droidconsultingti.com/droid.reparaciones.api/imagenes/icono-carro.png',
                    'anovehiculo' => $anovehiculo,
                    'codigocolorvehiculo' => $codigocolorvehiculo,
                    'fechahoracreacion' => $fechahoracreacion,
                    'usuariocreacion' => $usuariocreacion,
                    'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                array_push($array_completo_requerimiento, $array_row_requerimiento);
            }

            if (count($array_completo_requerimiento) > 0) {
                $this->_repositorioRequerimiento->codigozona = 1;
                $this->_repositorioRequerimiento->codigotipoinventario = 1;
                for ($i = 0; $i < count($array_completo_requerimiento); $i++) {
                    $this->_repositorioRequerimiento->codigorequerimiento = $array_completo_requerimiento[$i]['codigorequerimientoreal'];

                    // Ejecutar la funcion del repositorio
                    $resultadoinventario = $this->_repositorioRequerimiento->listarmininventarioporrequerimientozonatipoinventario();

                    // Conteo de filas
                    $numerofilasinventario = $resultadoinventario->rowCount();

                    if ($numerofilasinventario == 1) {
                        $rowinventario = $resultadoinventario->fetch(PDO::FETCH_ASSOC);
                        $urlimageninventario = $rowinventario['urlimagen'];
                        $array_completo_requerimiento[$i]['urlimagenmodelovehiculo'] = $urlimageninventario;
                    }
                }
            }

            // Crear respueta
            $respuesta = json_encode($array_completo_requerimiento);
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function listarporestadofechacreacionrucempresa($fechainicio, $fechafin, $rucempresa)
    {

        // Ejecutar la funcion del repositorio
        $resultadolistarestado = $this->_repositorioEstado->listar();

        // Conteo de filas
        $numerofilaslistarestado = $resultadolistarestado->rowCount();

        $array_completo_estado = array();

        if ($numerofilaslistarestado > 0) {

            while ($rowlistarestado = $resultadolistarestado->fetch(PDO::FETCH_ASSOC)) {
                extract($rowlistarestado);

                $array_row_estado = array(
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                array_push($array_completo_estado, $array_row_estado);
            }

            if (count($array_completo_estado) > 0) {

                $this->_repositorioRequerimiento->fechainicio = $fechainicio;
                $this->_repositorioRequerimiento->fechafin = $fechafin;
                $this->_repositorioRequerimiento->rucempresa = $rucempresa;

                for ($x = 0; $x < count($array_completo_estado); $x++) {
                    $codigoestado = $array_completo_estado[$x]['codigoestado'];

                    $this->_repositorioRequerimiento->codigoestado = $codigoestado;

                    // Ejecutar la funcion del repositorio
                    $resultadolistarporestadofechacreacion = $this->_repositorioRequerimiento->listarporestadofechacreacionrucempresa();

                    // Conteo de filas
                    $numerofilaslistarporestadofechacreacion = $resultadolistarporestadofechacreacion->rowCount();

                    if ($numerofilaslistarporestadofechacreacion > 0) {

                        $array_completo_requerimiento = array();

                        while ($rowlistarporestadofechacreacion = $resultadolistarporestadofechacreacion->fetch(PDO::FETCH_ASSOC)) {
                            extract($rowlistarporestadofechacreacion);

                            $array_row_requerimiento = array(
                                'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                                'codigorequerimientoreal' => $codigorequerimiento,
                                'codigotipopersona' => $codigotipopersona,
                                'descripciontipopersona' => $descripciontipopersona,
                                'codigotipodocumento' => $codigotipodocumento,
                                'descripciontipodocumento' => $descripciontipodocumento,
                                'numerotipodocumento' => $numerotipodocumento,
                                'nombres' => $nombres,
                                'apellidos' => $apellidos,
                                'ruc' => $ruc,
                                'razonsocial' => $razonsocial,
                                'correoelectronico' => $correoelectronico,
                                'telefono' => $telefono,
                                'numeroplacavehiculo' => $numeroplacavehiculo,
                                'vinvehiculo' => $vinvehiculo,
                                'codigomarcavehiculo' => $codigomarcavehiculo,
                                'codigomodelovehiculo' => $codigomodelovehiculo,
                                'urlimagenmodelovehiculo' => 'https://droidconsultingti.com/droid.reparaciones.api/imagenes/icono-carro.png',
                                'anovehiculo' => $anovehiculo,
                                'codigocolorvehiculo' => $codigocolorvehiculo,
                                'fechahoracreacion' => $fechahoracreacion,
                                'usuariocreacion' => $usuariocreacion,
                                'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                                'codigoestado' => $codigoestado,
                                'descripcionestado' => $descripcionestado
                            );

                            array_push($array_completo_requerimiento, $array_row_requerimiento);
                        }

                        if (count($array_completo_requerimiento) > 0) {
                            $this->_repositorioRequerimiento->codigozona = 1;
                            $this->_repositorioRequerimiento->codigotipoinventario = 1;
                            for ($i = 0; $i < count($array_completo_requerimiento); $i++) {
                                $this->_repositorioRequerimiento->codigorequerimiento = $array_completo_requerimiento[$i]['codigorequerimientoreal'];

                                // Ejecutar la funcion del repositorio
                                $resultadoinventario = $this->_repositorioRequerimiento->listarmininventarioporrequerimientozonatipoinventario();

                                // Conteo de filas
                                $numerofilasinventario = $resultadoinventario->rowCount();

                                if ($numerofilasinventario == 1) {
                                    $rowinventario = $resultadoinventario->fetch(PDO::FETCH_ASSOC);
                                    $urlimageninventario = $rowinventario['urlimagen'];
                                    $array_completo_requerimiento[$i]['urlimagenmodelovehiculo'] = $urlimageninventario;
                                }
                            }
                        }

                        $array_completo_estado[$x]['requerimientos'] = $array_completo_requerimiento;
                        $array_completo_estado[$x]['cantidadtotalrequerimientos'] = $numerofilaslistarporestadofechacreacion;
                    }
                }
            }

            // Crear respueta
            $respuesta = json_encode($array_completo_estado);
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function crearinventario(
        $codigorequerimiento,
        $codigozona,
        $codigotipoinventario,
        $informacioninventario
    ) {

        $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;
        $this->_repositorioRequerimiento->codigozona = $codigozona;
        $this->_repositorioRequerimiento->codigotipoinventario = $codigotipoinventario;

        // Ejecutar la funcion del repositorio
        $this->_repositorioRequerimiento->eliminarinventarioporrequerimientozonatipoinventario();

        if (is_array($informacioninventario) && count($informacioninventario) > 0) {
            for ($i = 0; $i < count($informacioninventario); $i++) {
                $detalle = $informacioninventario[$i]['detalle'];
                $urlimagen = $informacioninventario[$i]['urlimagen'];

                $this->_repositorioRequerimiento->detalle = $detalle;
                $this->_repositorioRequerimiento->urlimagen = $urlimagen;

                // Ejecutar la funcion del repositorio
                $this->_repositorioRequerimiento->crearinventario();
            }
            $respuesta = json_encode(
                array('mensaje' => 'Inventario registrado correctamente.', 'estado' => true)
            );
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Error al registrar el inventario del requerimiento.', 'estado' => false)
            );
        }
        // Enviar respuesta
        return $respuesta;
    }

    public function listarinventarioporrequerimientozonatipoinventario($codigorequerimiento, $codigozona, $codigotipoinventario)
    {

        $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;
        $this->_repositorioRequerimiento->codigozona = $codigozona;
        $this->_repositorioRequerimiento->codigotipoinventario = $codigotipoinventario;

        // Ejecutar la funcion del repositorio
        $resultado = $this->_repositorioRequerimiento->listarinventarioporrequerimientozonatipoinventario();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas > 0) {

            $array_completo_inventario = array();

            while ($rowinventario = $resultado->fetch(PDO::FETCH_ASSOC)) {
                extract($rowinventario);

                $array_row_inventario = array(
                    'codigoinventario' => $codigoinventario,
                    'codigorequerimiento' => $codigorequerimiento,
                    'codigotipoinventario' => $codigotipoinventario,
                    'descripciontipoinventario' => $descripciontipoinventario,
                    'codigozona' => $codigozona,
                    'descripcionzona' => $descripcionzona,
                    'detalle' => $detalle,
                    'urlimagen' => $urlimagen
                );
                array_push($array_completo_inventario, $array_row_inventario);
            }
            // Crear respueta
            $respuesta = json_encode($array_completo_inventario);
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function listarporcodigo($codigorequerimiento)
    {

        $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;

        // Ejecutar la funcion del repositorio
        $resultado = $this->_repositorioRequerimiento->listarporcodigo();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas == 1) {
            $requerimiento = array();

            while ($row = $resultado->fetch(PDO::FETCH_ASSOC)) {
                extract($row);

                $array_row = array(
                    'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                    'codigorequerimientoreal' => $codigorequerimiento,
                    'codigotipopersona' => $codigotipopersona,
                    'descripciontipopersona' => $descripciontipopersona,
                    'codigotipodocumento' => $codigotipodocumento,
                    'descripciontipodocumento' => $descripciontipodocumento,
                    'numerotipodocumento' => $numerotipodocumento,
                    'nombres' => $nombres,
                    'apellidos' => $apellidos,
                    'ruc' => $ruc,
                    'razonsocial' => $razonsocial,
                    'correoelectronico' => $correoelectronico,
                    'telefono' => $telefono,
                    'numeroplacavehiculo' => $numeroplacavehiculo,
                    'vinvehiculo' => $vinvehiculo,
                    'codigomarcavehiculo' => $codigomarcavehiculo,
                    'codigomodelovehiculo' => $codigomodelovehiculo,
                    'urlimagenmodelovehiculo' => 'https://droidconsultingti.com/droid.reparaciones.api/imagenes/icono-carro.png',
                    'anovehiculo' => $anovehiculo,
                    'codigocolorvehiculo' => $codigocolorvehiculo,
                    'fechahoracreacion' => $fechahoracreacion,
                    'usuariocreacion' => $usuariocreacion,
                    'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                $requerimiento = $array_row;
            }

            if (is_array($requerimiento)) {
                $this->_repositorioRequerimiento->codigozona = 1;
                $this->_repositorioRequerimiento->codigotipoinventario = 1;
                $this->_repositorioRequerimiento->codigorequerimiento = $requerimiento['codigorequerimientoreal'];

                // Ejecutar la funcion del repositorio
                $resultadoinventario = $this->_repositorioRequerimiento->listarmininventarioporrequerimientozonatipoinventario();

                // Conteo de filas
                $numerofilasinventario = $resultadoinventario->rowCount();

                if ($numerofilasinventario == 1) {
                    $rowinventario = $resultadoinventario->fetch(PDO::FETCH_ASSOC);
                    $urlimageninventario = $rowinventario['urlimagen'];
                    $requerimiento['urlimagenmodelovehiculo'] = $urlimageninventario;
                }
            }

            // Ejecutar la funcion del repositorio
            $resultadoinventario = $this->_repositorioRequerimiento->listarinventario();

            // Conteo de filas
            $numerofilasinventario = $resultadoinventario->rowCount();

            $array_completo_inventario = array();

            if ($numerofilasinventario > 0) {

                while ($rowinventario = $resultadoinventario->fetch(PDO::FETCH_ASSOC)) {
                    extract($rowinventario);

                    $array_row_inventario = array(
                        'codigoinventario' => $codigoinventario,
                        'codigorequerimiento' => $codigorequerimiento,
                        'codigotipoinventario' => $codigotipoinventario,
                        'descripciontipoinventario' => $descripciontipoinventario,
                        'codigozona' => $codigozona,
                        'descripcionzona' => $descripcionzona,
                        'detalle' => $detalle,
                        'urlimagen' => $urlimagen,
                        'urlicono' => $urlicono
                    );
                    array_push($array_completo_inventario, $array_row_inventario);
                }
            }

            $recepcion = array_filter($array_completo_inventario, function ($item) {
                return $item['codigotipoinventario'] == 1;
            });

            $entrega = array_filter($array_completo_inventario, function ($item) {
                return $item['codigotipoinventario'] == 2;
            });

            // Crear respueta
            $respuesta = json_encode(array('requerimiento' => $requerimiento, 'recepcion' => array_values($recepcion), 'entrega' => array_values($entrega), 'estado' => true));
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function enviarcorreoporcodigo($codigorequerimiento)
    {

        $this->_repositorioRequerimiento->codigorequerimiento = $codigorequerimiento;

        // Ejecutar la funcion del repositorio
        $resultado = $this->_repositorioRequerimiento->listarporcodigo();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas == 1) {
            $requerimiento = array();

            while ($row = $resultado->fetch(PDO::FETCH_ASSOC)) {
                extract($row);

                $array_row = array(
                    'codigorequerimiento' => "RE" . str_pad($codigorequerimiento, 10, "0", STR_PAD_LEFT),
                    'codigorequerimientoreal' => $codigorequerimiento,
                    'codigotipopersona' => $codigotipopersona,
                    'descripciontipopersona' => $descripciontipopersona,
                    'codigotipodocumento' => $codigotipodocumento,
                    'descripciontipodocumento' => $descripciontipodocumento,
                    'numerotipodocumento' => $numerotipodocumento,
                    'nombres' => $nombres,
                    'apellidos' => $apellidos,
                    'ruc' => $ruc,
                    'razonsocial' => $razonsocial,
                    'correoelectronico' => $correoelectronico,
                    'telefono' => $telefono,
                    'numeroplacavehiculo' => $numeroplacavehiculo,
                    'vinvehiculo' => $vinvehiculo,
                    'codigomarcavehiculo' => $codigomarcavehiculo,
                    'codigomodelovehiculo' => $codigomodelovehiculo,
                    'anovehiculo' => $anovehiculo,
                    'codigocolorvehiculo' => $codigocolorvehiculo,
                    'fechahoracreacion' => $fechahoracreacion,
                    'usuariocreacion' => $usuariocreacion,
                    'correoelectronicousuariocreacion' => $correoelectronicousuariocreacion,
                    'codigoestado' => $codigoestado,
                    'descripcionestado' => $descripcionestado
                );

                $requerimiento = $array_row;

                $respuestaEnvioCorreo = EnviarCorreo(
                    $requerimiento['correoelectronico'],
                    (!empty($requerimiento['nombres'])) ? $requerimiento['nombres'] . ' ' . $requerimiento['apellidos'] : (!empty($requerimiento['razonsocial']) ? $requerimiento['razonsocial'] : '-'),
                    $requerimiento['numeroplacavehiculo'],
                    $codigorequerimiento
                );

                if ($respuestaEnvioCorreo) {
                    $respuesta = json_encode(
                        array('mensaje' => 'Correo enviado correctamente.', 'estado' => true)
                    );
                } else {
                    $respuesta = json_encode(
                        array('mensaje' => 'Error al enviar el correo.', 'estado' => false)
                    );
                }
            }
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'No se encontró información.', 'estado' => false)
            );
        }

        return $respuesta;
    }
}