<?php

include_once '../../infraestructura/MySQL/RepositorioUsuario.php';
/* include_once '../../infraestructura/MySQL/RepositorioProveedor.php'; */
include_once '../../configuracion/Seguridad.php';

class ServicioUsuario
{
    private $_repositorioUsuario;
    /* private $_repositorioProveedor; */
    private $_seguridad;

    //Construct
    public function __construct()
    {
        $this->_repositorioUsuario = new RepositorioUsuario();
        /* $this->_repositorioProveedor = new RepositorioProveedor(); */
        $this->_seguridad = new Seguridad();
    }

    public function iniciarsesion(
        $correoelectronico,
        $contraseniaingresada
    ) {

        $codigousuarioUsuario = '';
        $correoelectronicoUsuario = '';
        $contraseniaHash = '';
        $nombreUsuario  = '';
        $apellidoUsuario  = '';
        $rucEmpresaUsuario  = '';
        $razonSocialEmpresaUsuario  = '';

        $this->_repositorioUsuario->correoelectronico = trim($correoelectronico);

        $resultadobuscarusuarioporcorreoelectronico = $this->_repositorioUsuario->buscarporcorreoelectronico();
        $numerofilasbuscarusuarioporcorreoelectronico = $resultadobuscarusuarioporcorreoelectronico->rowCount();

        if ($numerofilasbuscarusuarioporcorreoelectronico == 1) {
            $rowbuscarusuarioporcorreoelectronico = $resultadobuscarusuarioporcorreoelectronico->fetch(PDO::FETCH_ASSOC);
            $codigousuarioUsuario = $rowbuscarusuarioporcorreoelectronico['codigousuario'];
            $correoelectronicoUsuario = $rowbuscarusuarioporcorreoelectronico['correoelectronico'];
            $contraseniaHash = $rowbuscarusuarioporcorreoelectronico['contrasenia'];
            $nombreUsuario = $rowbuscarusuarioporcorreoelectronico['nombre'];
            $apellidoUsuario = $rowbuscarusuarioporcorreoelectronico['apellido'];
            $rucEmpresaUsuario = $rowbuscarusuarioporcorreoelectronico['rucempresa'];
            $razonSocialEmpresaUsuario = $rowbuscarusuarioporcorreoelectronico['razonsocialempresa'];

            if (password_verify($contraseniaingresada, $contraseniaHash)) {

                $rolesusuario = [];

                $this->_repositorioUsuario->codigousuario = $codigousuarioUsuario;
                $resultadorolesporusuario = $this->_repositorioUsuario->buscarrolesporusuario();
                // Conteo de filas
                $numerofilasrolesporusuario = $resultadorolesporusuario->rowCount();
                if ($numerofilasrolesporusuario > 0) {

                    while ($rowrolesporusuario = $resultadorolesporusuario->fetch(PDO::FETCH_ASSOC)) {
                        extract($rowrolesporusuario);

                        $array_row = array(
                            'codigorolusuario' => $codigorolusuario,
                            'descripcionrolusuario' => $descripcionrolusuario
                        );

                        // Insertar fila al array
                        array_push($rolesusuario, $array_row);
                    }
                }

                $token = $this->_seguridad->generarJWT($codigousuarioUsuario, $correoelectronicoUsuario);

                $respuesta = json_encode(
                    array(
                        'estado' => true,
                        'mensaje' => 'Ha ingresado correctamente.',
                        'usuario' => array(
                            'codigousuario' => $codigousuarioUsuario,
                            'correoelectronico' => $correoelectronicoUsuario,
                            'nombre' => $nombreUsuario,
                            'apellido' => $apellidoUsuario,
                            'rucempresa' => $rucEmpresaUsuario,
                            'razonsocialempresa' => $razonSocialEmpresaUsuario,
                            'roles' => $rolesusuario
                        ),
                        'token' => $token['token']
                    )
                );
            } else {
                $respuesta = json_encode(
                    array(
                        'mensaje' => 'Credenciales inválidas.',
                        'estado' => false
                    )
                );
            }
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Usuario inválido.', 'estado' => false)
            );
        }

        return $respuesta;
    }

    public function validarToken(
        $headers
    ) {
        //Validar JWT
        $validarTEMP = $this->_seguridad->validarJWT($headers);

        $validarJWT = json_decode(json_encode($validarTEMP), true);

        if (isset($validarJWT['estadojwt'])) {
            return $validarJWT;
        }

        // Enviar valor a propiedades
        $this->_repositorioUsuario->codigousuario = $validarJWT['codigousuario'];
        $this->_repositorioUsuario->ruccorreoelectronico = $validarJWT['correoelectronico'];

        $resultado = $this->_repositorioUsuario->validarToken();

        // Conteo de filas
        $numerofilas = $resultado->rowCount();

        if ($numerofilas > 0) {
            $respuesta = array(
                'mensaje' => 'Autorizado para consumir el recurso.',
                'estadojwt' => true
            );
        } else {
            $respuesta = array(
                'mensaje' => 'No está autorizado para consumir el recurso.',
                'estadojwt' => false
            );
        }

        // Enviar respuesta
        return $respuesta;
    }

    public function crear(
        $nombre,
        $apellido,
        $correoelectronico,
        $celular,
        $rucempresa,
        $razonsocialempresa,
        $contrasenia
    ) {

        $this->_repositorioUsuario->correoelectronico = trim($correoelectronico);

        $resultadobuscarusuarioporcorreoelectronico = $this->_repositorioUsuario->buscarporcorreoelectronico();
        $numerofilasbuscarusuarioporcorreoelectronico = $resultadobuscarusuarioporcorreoelectronico->rowCount();

        if ($numerofilasbuscarusuarioporcorreoelectronico == 0) {
            $this->_repositorioUsuario->nombre = $nombre;
            $this->_repositorioUsuario->apellido = $apellido;
            $this->_repositorioUsuario->celular = $celular;
            $this->_repositorioUsuario->rucempresa = $rucempresa;
            $this->_repositorioUsuario->razonsocialempresa = $razonsocialempresa;
            $this->_repositorioUsuario->contrasenia = password_hash($contrasenia, PASSWORD_DEFAULT);

            // Ejecutar la funcion del repositorio
            $resultado = $this->_repositorioUsuario->crear();

            // Crear respueta
            if ($resultado) {

                // Enviar valor a propiedades
                $this->_repositorioUsuario->codigousuario = $resultado;
                $this->_repositorioUsuario->codigorolusuario = 1;

                // Ejecutar la funcion del repositorio
                $resultadoCrearUsuarioRol = $this->_repositorioUsuario->crearusuariorol();

                if ($resultadoCrearUsuarioRol) {
                    $respuesta = json_encode(
                        array('mensaje' => 'Usuario creado correctamente.', 'estado' => true)
                    );
                } else {
                    $respuesta = json_encode(
                        array('mensaje' => 'Error al crear el usuario.', 'estado' => false)
                    );
                }
            } else {
                $respuesta = json_encode(
                    array('mensaje' => 'Error en la creación del usuario.', 'estado' => false)
                );
            }
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Correo electrónico ya existe.', 'estado' => false)
            );
        }

        // Enviar respuesta
        return $respuesta;
    }

    public function olvidarcontrasenia(
        $ruccorreoelectronico,
    ) {

        $this->_repositorioUsuario->correoelectronico = $ruccorreoelectronico;
        $resultadobusquedausuario = $this->_repositorioUsuario->buscarporcorreoelectronico();
        // Conteo de filas
        $numerofilasbusquedausuario = $resultadobusquedausuario->rowCount();
        if ($numerofilasbusquedausuario > 0) {
            $row = $resultadobusquedausuario->fetch(PDO::FETCH_ASSOC);
            $codigousuario = $row['codigousuario'];
            $nombre = $row['nombre'];
            $correoelectronico = $row['correoelectronico'];
        }

        if ($codigousuario != false) {
            // Enviar valor a propiedades
            $contraseniaTEMP = RetornarContraseniaAleatoria();

            $this->_repositorioUsuario->codigousuario = $codigousuario;
            $this->_repositorioUsuario->contrasenia = password_hash($contraseniaTEMP, PASSWORD_DEFAULT);

            // Ejecutar la funcion del repositorio
            $resultado = $this->_repositorioUsuario->restablecercontrasenia();

            // Crear respueta
            if ($resultado) {
                $contenidoprincipal = "<p>Estimado <b>{$nombre}</b>,</p>
            <p>Se reestableció la contraseña de su cuenta {$correoelectronico}. Por favor ingresar al siguiente link: <a href='https://droidconsultingti.com/Taller'>Portal del Taller</a></p>
            <br>
            <p><b>Credenciales</b></p>
            <p><b>Nueva Contraseña:</b> {$contraseniaTEMP}</p>";
                $respuestaEnvioCorreoReestablecer = EnviarCorreoBase($contenidoprincipal, $correoelectronico, $nombre, "[Taller DROID]: Restablecimiento de Credenciales");

                if ($respuestaEnvioCorreoReestablecer) {
                    $respuesta = json_encode(
                        array('mensaje' => 'Contraseña restablecida correctamente.', 'estado' => true)
                    );
                } else {
                    $respuesta = json_encode(
                        array('mensaje' => 'Error en el envío del correo.', 'estado' => false)
                    );
                }
            } else {
                $respuesta = json_encode(
                    array('mensaje' => 'Error al restablecer la contraseña del usuario.', 'estado' => false)
                );
            }
        } else {
            $respuesta = json_encode(
                array('mensaje' => 'Error al restablecer la contraseña del usuario.', 'estado' => false)
            );
        }

        // Enviar respuesta
        return $respuesta;
    }
}
