<?php

use Fpdf\Fpdf;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

function ValidarAuthControladores($headers)
{
    include_once '../../servicios/ServicioUsuario.php';
    $servicioUsuario = new ServicioUsuario();
    $respuestaValidacionToken = $servicioUsuario->validarToken($headers);

    if ($respuestaValidacionToken['estadojwt'] == false) {
        echo json_encode($respuestaValidacionToken);
        exit;
    }
}
function RetornarHostApisNetSunat()
{
    $url = 'https://api.apis.net.pe/v2/sunat/';
    return $url;
}
function RetornarTokenApisNetSunat()
{
    $token = 'apis-token-7741.suKQ93zf8kzv8z0DL8A5bwEnRTxVO-90';
    return $token;
}
function base64ToFile($base64String, $outputFile)
{
    // Extraer el MIME type y la data base64 usando una expresión regular
    if (preg_match('/^data:(\w+\/\w+);base64,/', $base64String, $matches)) {
        $mimeType = $matches[1];
        $base64Data = substr($base64String, strpos($base64String, ',') + 1);
        $base64Data = base64_decode($base64Data);

        if ($base64Data === false) {
            return false; // La decodificación falló
        }

        // Determinar la extensión del archivo basada en el MIME type
        $extensions = [
            'image/jpeg' => 'jpg',
            'image/png' => 'png',
            'image/gif' => 'gif',
            'application/pdf' => 'pdf',
            'text/plain' => 'txt',
            // Agregar otros MIME types y extensiones según sea necesario
        ];

        if (!array_key_exists($mimeType, $extensions)) {
            return false; // MIME type no soportado
        }

        $extension = $extensions[$mimeType];
        $outputFile = "archivos/{$outputFile}.{$extension}";

        // Guardar el archivo en el sistema de archivos
        if (file_put_contents($outputFile, $base64Data) === false) {
            return false; // Fallo al guardar el archivo
        }

        return $outputFile; // Retorna la ruta del archivo guardado
    } else {
        return false; // No se pudo extraer el MIME type
    }
}

function generateRandomFileName($length = 16)
{
    // Genera bytes aleatorios y los convierte a una cadena hexadecimal
    $randomString = bin2hex(random_bytes($length / 2));
    return $randomString;
}

function returnBaseUrlProject()
{
    /* return "http://localhost:80/Droid/droid.reparaciones.api/"; */
    return "https://droidconsultingti.com/droid.reparaciones.api/";
}

function generarDocumentoRequerimiento($datos)
{

    $pdf = new FPDF();
    $pdf->SetMargins(1, 1, 1); // Margen izquierdo, superior y derecho en 10 mm
    $pdf->AddPage();
    /* TITULO */
    $pdf->SetFillColor(255, 192, 0);
    $pdf->SetFont('Arial', 'B', 12);
    // Usar iconv para convertir a ISO-8859-1 si es necesario
    $titulo = iconv('UTF-8', 'ISO-8859-1', 'Inventario del Automóvil');
    $pdf->Cell(0, 10, $titulo, 0, 1, 'C', true);
    $pdf->Ln(2);
    /* PRIMERA SECCION */

    $requerimiento = $datos->requerimiento;

    $splitFecha = ($requerimiento->fechahoracreacion) ? explode(" ", $requerimiento->fechahoracreacion) : '';
    $fecha = (count($splitFecha) == 2) ? $splitFecha[0] : '-';
    setlocale(LC_TIME, 'es_ES.UTF-8'); // Establecer la configuración regional a español
    $date = new DateTime($fecha);
    // Formatear la fecha
    $formattedDate = $date->format('d \d\e F \d\e Y');
    $hora = (count($splitFecha) == 2) ? $splitFecha[1] : '-';

    // Establecer la fuente
    $pdf->SetFont('Arial', '', 10);
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde superior
    // Fecha
    $pdf->Cell(30, 10, 'Fecha:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, $formattedDate, 1, 1); // Borde derecho
    // Hora
    $pdf->Cell(30, 10, 'Hora:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, $hora, 1, 1); // Borde derecho
    // Motivo
    $pdf->Cell(30, 10, 'Motivo:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', 'Recepción del vehículo'), 1, 1); // Borde derecho
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde inferior
    // Salto de línea
    $pdf->Ln(1);

    /* SEGUNDA SECCION */

    // Agregar título debajo de la sección
    $pdf->SetFont('Arial', 'B', 11);
    $pdf->Cell(0, 10, 'Datos del Propietario', 0, 1, 'L');
    // Salto de línea
    $pdf->Ln(1);

    $dniRuc = (!empty($requerimiento->numerotipodocumento)) ? $requerimiento->numerotipodocumento : (!empty($requerimiento->ruc) ? $requerimiento->ruc : '-');
    $descripcion = (!empty($requerimiento->nombres)) ? $requerimiento->nombres . ' ' . $requerimiento->apellidos : (!empty($requerimiento->razonsocial) ? $requerimiento->razonsocial : '-');

    // Establecer la fuente
    $pdf->SetFont('Arial', '', 10);
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde superior
    // DNI/RUC
    $pdf->Cell(30, 10, 'DNI/RUC:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, $dniRuc, 1, 1); // Borde derecho
    // Descripción
    $pdf->Cell(30, 10, iconv('UTF-8', 'ISO-8859-1', 'Descripción:'), 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', $descripcion), 1, 1); // Borde derecho
    // Correo
    $pdf->Cell(30, 10, 'Correo:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', $requerimiento->correoelectronico), 1, 1); // Borde derecho
    // Teléfono
    $pdf->Cell(30, 10, iconv('UTF-8', 'ISO-8859-1', 'Teléfono:'), 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', $requerimiento->telefono), 1, 1); // Borde derecho
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde inferior
    // Salto de línea
    $pdf->Ln(1);

    /* TERCERA SECCION */

    // Agregar título debajo de la sección
    $pdf->SetFont('Arial', 'B', 11);
    $tituloDatosVehiculo = iconv('UTF-8', 'ISO-8859-1', 'Datos del Vehículo');
    $pdf->Cell(0, 10, $tituloDatosVehiculo, 0, 1, 'L');
    // Salto de línea
    $pdf->Ln(1);

    $descripcionVehiculo = (!empty($requerimiento->codigomarcavehiculo)) ? $requerimiento->codigomarcavehiculo . ' ' . $requerimiento->codigomodelovehiculo . ' ' . $requerimiento->anovehiculo . ' ' . $requerimiento->codigocolorvehiculo : '-';

    // Establecer la fuente
    $pdf->SetFont('Arial', '', 10);
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde superior
    // DNI/RUC
    $pdf->Cell(30, 10, 'Placa:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', $requerimiento->numeroplacavehiculo), 1, 1); // Borde derecho
    // Descripción
    $pdf->Cell(30, 10, iconv('UTF-8', 'ISO-8859-1', 'Descripción:'), 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, iconv('UTF-8', 'ISO-8859-1', $descripcionVehiculo), 1, 1); // Borde derecho
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde inferior
    // Salto de línea
    $pdf->Ln(1);

    /* CUARTA SECCION */

    // Agregar título debajo de la sección
    $pdf->SetFont('Arial', 'B', 11);
    $pdf->Cell(0, 10, 'Datos del Seguro', 0, 1, 'L');
    // Salto de línea
    $pdf->Ln(1);

    // Establecer la fuente
    $pdf->SetFont('Arial', '', 10);
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde superior
    // RUC
    $pdf->Cell(30, 10, 'RUC:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, '-', 1, 1); // Borde derecho
    // Razón Social
    $pdf->Cell(30, 10, iconv('UTF-8', 'ISO-8859-1', 'Razón Social:'), 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, '-', 1, 1); // Borde derecho
    // No. de Poliza
    $pdf->Cell(30, 10, 'No. de Poliza:', 1, 0); // Borde izquierdo
    $pdf->Cell(0, 10, '-', 1, 1); // Borde derecho
    // Crear una celda para la sección completa con bordes
    $pdf->Cell(0, 0, '', 1, 1); // Borde inferior
    // Salto de línea
    $pdf->Ln(1);

    /* QUINTA SECCION */

    $recepcion = $datos->recepcion;
    $resultadoZonas = getUniqueObjectsByProperty($recepcion, 'codigozona');
    $informacion = array();
    if (is_array($resultadoZonas) && count($resultadoZonas) > 0) {
        for ($i = 0; $i < count($resultadoZonas); $i++) {
            $codigozona = $resultadoZonas[$i]->codigozona;
            $descripcionzona = $resultadoZonas[$i]->descripcionzona;
            $urlicono = $resultadoZonas[$i]->urlicono;

            $detallesPorZona = filterByObjectProperty($recepcion,  'codigozona', $codigozona);
            $detalleCompleto = '';

            // Acceder a la propiedad 'detalle' de cada objeto
            foreach ($detallesPorZona as $item) {
                $detalle = $item->detalle ? $item->detalle . "\n" : '';
                $detalleCompleto .= $detalle;
            }

            array_push($informacion, array('descripcionzona' => $descripcionzona, 'urlicono' => $urlicono, 'detalle' => $detalleCompleto));
        }
    }

    // Agregar título debajo de la sección
    $pdf->SetFont('Arial', 'B', 11);
    $pdf->Cell(0, 10, 'Inventario', 0, 1, 'L');
    // Salto de línea
    $pdf->Ln(1);

    // Establecer el ancho de las columnas
    $imageColumnWidth = 15;
    $textColumnWidth = 193;


    // Recorrer las filas de la tabla
    for ($i = 0; $i < count($informacion); $i++) {
        // Posición inicial de la fila
        $x = $pdf->GetX();
        $y = $pdf->GetY();
        // Calcular el alto de la fila basada en el número de líneas
        $numLines = substr_count($informacion[$i]['detalle'], "\n") + 1;
        $rowHeight = $numLines * 4;
        $rowHeightAdjusted = $rowHeight / $numLines;
        // Celda para la imagen con borde
        $pdf->Cell($imageColumnWidth, $rowHeight - 1, '', 1, 0);
        // Ajustar la posición y el ancho de la imagen dentro de la celda
        $pdf->Image($informacion[$i]['urlicono'], $x + 1, $y + 1, 12);
        // Establecer el tamaño de la fuente para `MultiCell`
        $pdf->SetFont('Arial', '', 10);
        // Celda para el texto con borde
        $pdf->MultiCell($textColumnWidth, $rowHeightAdjusted + 1, iconv('UTF-8', 'ISO-8859-1', $informacion[$i]['detalle']), 1);
    }

    $pdfContent = $pdf->Output('S'); // 'S' significa que la salida será devuelta como una cadena
    return $pdfContent;
}

// Función para obtener arrays únicos basados en una propiedad
function getUniqueObjectsByProperty($array, $property)
{
    $tempArray = [];
    $keyArray = [];

    foreach ($array as $obj) {
        if (!in_array($obj->{$property}, $keyArray)) {
            $keyArray[] = $obj->{$property};
            $tempArray[] = $obj;
        }
    }
    return $tempArray;
}

// Filtrar el array de objetos por valor de propiedad
function filterByObjectProperty($array, $property, $value)
{
    return array_filter($array, function ($item) use ($property, $value) {
        return isset($item->$property) && $item->$property == $value;
    });
}

function EnviarCorreo(
    $correoelectronico,
    $nombre,
    $placa,
    $codigorequerimiento
) {

    include_once '../../plugins/vendor/autoload.php';

    try {
        $contenido = "<html>
        <head>
        <style>
        .foot { display: inline-block; line-height: 70px; vertical-align: top }
        .rounded-button {
            display: inline-block;
            padding: 10px 20px;
            font-size: 16px;
            color: #fff;
            background-color: #007bff;
            border-radius: 25px;
            text-align: center;
            text-decoration: none;
            transition: background-color 0.3s;
        }
        .rounded-button:hover {
            background-color: #0056b3;
        }
        </style>
        </head>
        <body>
        <br>
        <p>Estimado <b>{$nombre}</b></p>
        <p>Por medio del presente le hacemos llegar el siguiente enlace para que le de seguimiento a su vehículo:</p>
        <a href='https://droidconsultingti.com/MiTaller/user-page/{$codigorequerimiento}' class='rounded-button'>Haz clic aquí</a>
        <br>
        <p><b>Saludos Cordiales</b></p>
        <hr>
        <div class='siteFooterBar'>
            <div class='content'>
                <div class='foot'><b>DROID © Copyright 2024</b> - Todos los Derechos Reservados.</div>
            </div>
        </div>
        </body>
        </html>
        ";

        //Config.
        $mail = new PHPMailer();
        $mail->CharSet = "UTF-8";
        $mail->isSMTP();
        $mail->Port       = 465;
        $mail->SMTPAuth   = true;
        $mail->Host = 'mail.droidconsultingti.com';
        $mail->Username = 'contacto@droidconsultingti.com';
        $mail->Password = 'Lima123456/*';
        /* $mail->Host = 'ssl://smtp.gmail.com'; */
        /* $mail->Username = 'serviciosti.ach@gmail.com'; */
        /* $mail->Password = 'lhglorhiomfwzlhz'; */
        $mail->SMTPSecure = 'ssl';

        //Emisor
        $mail->setFrom('contacto@droidconsultingti.com', 'DROID');

        //Receptor
        $mail->addAddress($correoelectronico, $nombre);

        //Contenido
        $mail->isHTML(true);
        $mail->Subject = "[Taller DROID]: Seguimiento Vehículo {$placa}";
        $mail->Body    = $contenido;

        //Envio
        if (!$mail->send()) {
            return false;
        } else {
            return true;
        }
    } catch (Exception $e) {
        echo "Hubo un error al enviar el correo: {$mail->ErrorInfo}";
    }
}

function EnviarCorreoBase(
    $contenidoprincipal,
    $correoelectronico,
    $nombre,
    $asunto
) {

    include_once '../../plugins/vendor/autoload.php';

    try {
        $contenido = "<html>
        <head>
        <style>
        .foot { display: inline-block; line-height: 70px; vertical-align: top }
        </style>
        </head>
        <body>
        <br>
        {$contenidoprincipal}
        <br>
        <p><b>Saludos Cordiales</b></p>
        <hr>
        <div class='siteFooterBar'>
            <div class='content'>
                <div class='foot'><b>DROID © Copyright 2024</b> - Todos los Derechos Reservados.</div>
            </div>
        </div>
        </body>
        </html>
        ";

        //Config.
        $mail = new PHPMailer();
        $mail->CharSet = "UTF-8";
        $mail->isSMTP();
        /* $mail->Host = 'ssl://smtp.gmail.com'; */
        /* $mail->Username = 'serviciosti.ach@gmail.com'; */
        /* $mail->Password = 'lhglorhiomfwzlhz'; */
        $mail->Port       = 465;
        $mail->SMTPAuth   = true;
        $mail->Host = 'mail.droidconsultingti.com';
        $mail->Username = 'contacto@droidconsultingti.com';
        $mail->Password = 'Lima123456/*';
        $mail->SMTPSecure = 'ssl';

        //Emisor
        $mail->setFrom('contacto@droidconsultingti.com', 'DROID');
        /* $mail->setFrom('serviciosti.ach@gmail.com', 'DROID'); */

        //Receptor
        $mail->addAddress($correoelectronico, $nombre);

        //Contenido
        $mail->isHTML(true);
        $mail->Subject = $asunto;
        $mail->Body    = $contenido;

        //Envio
        if (!$mail->send()) {
            return false;
        } else {
            return true;
        }
    } catch (Exception $e) {
        echo "Hubo un error al enviar el correo: {$mail->ErrorInfo}";
    }
}

function RetornarContraseniaAleatoria()
{
    $permitted_chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%&_';

    $longitud = 10;
    $min_uppercase = 1;
    $min_number = 1;
    $min_special = 1;

    $contrasenia = '';

    $contrasenia .= substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 0, $min_uppercase);
    $contrasenia .= substr(str_shuffle('0123456789'), 0, $min_number);
    $contrasenia .= substr(str_shuffle('!@#$%&_'), 0, $min_special);

    $contrasenia .= substr(str_shuffle($permitted_chars), 0, $longitud - $min_uppercase - $min_number - $min_special);

    $contrasenia = str_shuffle($contrasenia);

    return $contrasenia;
}
